//---------------------------------------------------------------------------
//
//  simplecvi.c
//  
//  Basic UD example for LabWindows/CVI.  Tested in CVI version 5.5.
//  This source code is the exact same as the source from our VC6_LJUD
//  simple example, so any of the other VC6_LJUD examples can also be
//	used in CVI.  The process is:
//
//	1)  Make a new project.
//
//	2)  Choose "Edit => Add Files To Project..." and add the desired C file.
//
//	3)  Do the same and add the UD lib file.  The lib file is normally
//	located in ...\labjack\drivers\labjackud.lib.
//
//	4)  Do Ctrl+M to build the project.
//
//	5)  Do Shift+F5 to run the project.
//
//  support@labjack.com
//  12/2005
//----------------------------------------------------------------------
//

#include <stdio.h>
#include "c:\program files\labjack\drivers\LabJackUD.h"


main()
{
	long lngErrorcode;
	long lngIOType=0, lngChannel=0;
	double dblValue=0;
	double Value2=0,Value3=0;
	double ValueDIBit=0,ValueDIPort=0;
	LJ_HANDLE lngHandle=0;
	char err[255];
	char ch;


	//Open the first found LabJack UE9.
	lngErrorcode = OpenLabJack (LJ_dtUE9, LJ_ctUSB, "1", 1, &lngHandle);
	//lngErrorcode = OpenLabJack (LJ_dtUE9, LJ_ctETHERNET, "192.168.1.209", 0, &lngHandle);
	if(lngErrorcode) goto ErrorMessage;


	//Configure for 16-bit analog input measurements.
	lngErrorcode = AddRequest (lngHandle, LJ_ioPUT_CONFIG, LJ_chAIN_RESOLUTION, 16, 0, 0);
	if(lngErrorcode) goto ErrorMessage;

	//Configure the analog input range on channels 2 and 3 for bipolar gain=1.
	lngErrorcode = AddRequest (lngHandle,  LJ_ioPUT_AIN_RANGE, 2, LJ_rgBIP5V, 0, 0);
	if(lngErrorcode) goto ErrorMessage;

	lngErrorcode = AddRequest (lngHandle,  LJ_ioPUT_AIN_RANGE, 3, LJ_rgBIP5V, 0, 0);
	if(lngErrorcode) goto ErrorMessage;

	//Request AIN2 and AIN3.
	lngErrorcode = AddRequest (lngHandle, LJ_ioANALOG_INPUT, 2, 0, 0, 0);
	if(lngErrorcode) goto ErrorMessage;

	lngErrorcode = AddRequest (lngHandle, LJ_ioANALOG_INPUT, 3, 0, 0, 0);
	if(lngErrorcode) goto ErrorMessage;

	//Set DAC0 to 2.5 volts.
	lngErrorcode = AddRequest (lngHandle, LJ_ioANALOG_OUTPUT, 0, 2.5, 0, 0);
	if(lngErrorcode) goto ErrorMessage;

	//Read digital input FIO0.
	lngErrorcode = AddRequest (lngHandle, LJ_ioDIGITAL_BIT_IN, 0, 0, 0, 0);
	if(lngErrorcode) goto ErrorMessage;

	//Set digital output FIO1 to output-high.
	lngErrorcode = AddRequest (lngHandle, LJ_ioDIGITAL_BIT_OUT, 1, 1, 0, 0);
	if(lngErrorcode) goto ErrorMessage;

	//Read digital inputs FIO2 through FIO7.
	lngErrorcode = AddRequest (lngHandle, LJ_ioDIGITAL_PORT_IN, 2, 0, 6, 0);
	if(lngErrorcode) goto ErrorMessage;


	while (1)
	{
	   //Execute the requests.
		lngErrorcode = GoOne (lngHandle);
		if(lngErrorcode) goto ErrorMessage;

	   	//Get all the results.  The analog input measurement results are stored.  All other
		//results are for configuration requests so we are just checking whether there
		//was an error.
		lngErrorcode = GetFirstResult(lngHandle, &lngIOType, &lngChannel, &dblValue, 0, 0);
		if(lngErrorcode) goto ErrorMessage;
		while(!lngErrorcode)
		{
			lngErrorcode = GetNextResult(lngHandle, &lngIOType, &lngChannel, &dblValue, 0, 0);
			if((lngIOType==LJ_ioANALOG_INPUT)&&(lngChannel==2)) Value2=dblValue;
			if((lngIOType==LJ_ioANALOG_INPUT)&&(lngChannel==3)) Value3=dblValue;
			if((lngIOType==LJ_ioDIGITAL_BIT_IN)&&(lngChannel==0)) ValueDIBit=dblValue;
			if((lngIOType==LJ_ioDIGITAL_PORT_IN)&&(lngChannel==2)) ValueDIPort=dblValue;
		}
		if(lngErrorcode==LJE_NO_MORE_DATA_AVAILABLE) lngErrorcode=0;
		if(lngErrorcode) goto ErrorMessage;

		printf("AIN2 = %f\n",Value2);
  		printf("AIN3 = %f\n",Value3);
		printf("FIO0 = %f\n",ValueDIBit);
		printf("FIO2-FIO7 = %f\n",ValueDIPort);  //Will read 63 if all 6 lines are pulled-high as normal.

		printf("\nPress Enter to go again or (q) to quit\n");
		ch = getchar();
		if (ch == 'q') return 0;
	}



//A very simple error handler that works fine for a console program like this.
ErrorMessage:
    ErrorToString(lngErrorcode,err);
    printf("\nError message = %s\n",err);
	getchar();
	return 0;
}
